/*  
 * radiodinit.c
 * 
 * freely adapted from xradioinit.c
 *
 * freely adapted from xradiotrack V.1.1 program 
 *
 * freely adapted from gideon legrange's radio.c for xradiotrack
 *
 * for explanation of the X-coding, see comments in xradiocard.c
 *
 * $Id: radiodinit.c,v 1.6 1997/08/05 15:32:09 anad Exp $	

*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <syslog.h>
#include "radiodinit.h"

extern long RadioType;
extern int used;

/* ******* The Actual Error Handler **************** */

void have_error(int errcode)
{
char *errlines[8];

errlines[0] = "unrecognised error ";
errlines[1] = "error opening /etc/radio.conf ";
errlines[2] = "port not set or illegal value in /etc/radio.conf ";
errlines[3] = "need IO permissions, must run as root or setuid root ";
errlines[4] = "invalid frequency in /etc/radio.conf";
errlines[5] = "invalid default station in /etc/radio.conf";
errlines[6] = "syntax error in /etc/radio.conf";
errlines[7] = "invalid card type in /etc/radio.conf";

syslog(LOG_DAEMON+LOG_ERR, "%s: %m", errlines[errcode]);
closelog();
exit(1);

}

/* *************************INIT Routines*************** */

int do_init(void)
{
int m;
/*
int RootBase;
int RootType;
char *homedir;
*/
/* to be certain, init frequencies to zero and names to empty */

for (m=0;m<NumStations;m++)
   {
   stations[m].freq=0;
   stations[m].name[0]='\0';
   }

yyin=fopen("/etc/radio.conf","r");
if (yyin==NULL) { have_error(1); }

yylex();

fclose(yyin);

/* ok, now station info in station array and default array */

if (!(RadioBase==0x30c || RadioBase==0x20c)) { have_error(2);}
/*
RootBase=RadioBase;
RootType=RadioType;

homedir=getenv("HOME");
if (homedir!=NULL)
   {
   strcat(homedir,"/.radio.conf");
   yyin=fopen(homedir,"r");
   if (yyin!=NULL) {
      used=0;
      for (m=0;m<NumStations;m++)
      {
      stations[m].freq=0;
      stations[m].name[0]='\0';
      }
      yylex();
      fclose(yyin);
      }
   }

RadioBase=RootBase;
RadioType=RootType;
*/
/* first ask for the radio card ports */

m=get_io_privs(RadioBase);
if (m!=0) { have_error(3);}

/* now give up root */

give_up_root();
return(0);
}
